Debian Bug report logs - #589896
openarena: segfaults when using pulse-via-ALSA output and PulseAudio capture

version graph

Package: libasound2; Maintainer for libasound2 is Debian ALSA Maintainers <pkg-alsa-devel@lists.alioth.debian.org>; Source for libasound2 is src:alsa-lib.

Reported by: Simon McVittie <smcv@debian.org>

Date: Thu, 22 Jul 2010 00:06:02 UTC

Severity: grave

Tags: patch

Merged with 593422

Found in version alsa-lib/1.0.23-1

Fixed in version alsa-lib/1.0.23-2.1

Done: Simon McVittie <smcv@debian.org>

Bug is archived. No further changes may be made.

Forwarded to https://bugtrack.alsa-project.org/alsa-bug/view.php?id=4426

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, Debian Games Team <pkg-games-devel@lists.alioth.debian.org>:
Bug#589896; Package openarena. (Thu, 22 Jul 2010 00:06:04 GMT) Full text and rfc822 format available.

Acknowledgement sent to Simon McVittie <smcv@debian.org>:
New Bug report received and forwarded. Copy sent to Debian Games Team <pkg-games-devel@lists.alioth.debian.org>. (Thu, 22 Jul 2010 00:06:04 GMT) Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Simon McVittie <smcv@debian.org>
To: Debian Bug Tracking System <submit@bugs.debian.org>
Subject: openarena: segfaults when using pulse-via-ALSA output and PulseAudio capture
Date: Thu, 22 Jul 2010 01:02:29 +0100
[Message part 1 (text/plain, inline)]
Package: openarena
Version: 0.8.1-7
Severity: normal

OA can be configured such that it segfaults on startup. I believe this is
caused by the following situation, which I might have got into by
reconfiguring it to make better use of PulseAudio in the past:

- OpenAL enabled (+set s_useOpenAL 1)
- output (s_alDevice) is "ALSA Software", which is in turn configured via
  .asoundrc to use the ALSA pulse plugin
- OpenAL capture source, selected automatically by the engine, is PulseAudio
- audio capture enabled (set s_alCapture 1)

I could work around this by either setting s_alDevice to "PulseAudio Software"
or setting s_alCapture to 0. These settings get saved to q3config.cfg
automatically.

This might be the same as this Ubuntu bug:

    https://bugs.launchpad.net/ubuntu/+source/pulseaudio/+bug/584393

-- System Information:
Debian Release: squeeze/sid
  APT prefers unstable
  APT policy: (500, 'unstable'), (500, 'testing'), (500, 'stable'), (101, 'experimental')
Architecture: amd64 (x86_64)

Kernel: Linux 2.6.32-5-amd64 (SMP w/2 CPU cores)
Locale: LANG=en_GB.UTF-8, LC_CTYPE=en_GB.UTF-8 (charmap=UTF-8)
Shell: /bin/sh linked to /bin/dash

Versions of packages openarena depends on:
ii  libc6                     2.11.2-2       Embedded GNU C Library: Shared lib
ii  libcurl3-gnutls           7.21.0-1       Multi-protocol file transfer libra
ii  libgl1-mesa-glx [libgl1]  7.7.1-4        A free implementation of the OpenG
ii  libogg0                   1.2.0~dfsg-1   Ogg bitstream library
ii  libopenal1                1:1.12.854-2   Software implementation of the Ope
ii  libsdl1.2debian           1.2.14-6       Simple DirectMedia Layer
ii  libspeex1                 1.2~rc1-1      The Speex codec runtime library
ii  libspeexdsp1              1.2~rc1-1      The Speex extended runtime library
ii  libvorbis0a               1.3.1-1        The Vorbis General Audio Compressi
ii  libvorbisfile3            1.3.1-1        The Vorbis General Audio Compressi
ii  openarena-data            0.8.1+dfsg1-1  OpenArena game data
ii  openarena-server          0.8.1-8        game server for the game OpenArena

openarena recommends no packages.

openarena suggests no packages.

-- no debconf information
[oa-pulse-capture.txt (text/plain, attachment)]
[signature.asc (application/pgp-signature, inline)]

Severity set to 'grave' from 'normal' Request was from Simon McVittie <smcv@debian.org> to control@bugs.debian.org. (Thu, 19 Aug 2010 20:15:06 GMT) Full text and rfc822 format available.

Merged 589896 593422. Request was from Simon McVittie <smcv@debian.org> to control@bugs.debian.org. (Thu, 19 Aug 2010 20:15:07 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Games Team <pkg-games-devel@lists.alioth.debian.org>:
Bug#589896; Package openarena. (Fri, 20 Aug 2010 18:27:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Simon McVittie <smcv@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian Games Team <pkg-games-devel@lists.alioth.debian.org>. (Fri, 20 Aug 2010 18:27:04 GMT) Full text and rfc822 format available.

Message #14 received at 589896@bugs.debian.org (full text, mbox):

From: Simon McVittie <smcv@debian.org>
To: Jordan Metzmeier <jordan@linuxgen.com>, 589896@bugs.debian.org, pkg-alsa-devel@lists.alioth.debian.org, pkg-voip-maintainers@lists.alioth.debian.org
Subject: Re: Bug#589896: openarena: segfaults when using pulse-via-ALSA output and PulseAudio capture
Date: Fri, 20 Aug 2010 19:22:39 +0100
[Message part 1 (text/plain, inline)]
reassign 589896 libasound2
found 589896 1.0.23-1
affects 589896 openarena libportaudio2
thanks

On Fri, 20 Aug 2010 at 00:41:13 +0100, Simon McVittie wrote:
> I think I somewhat understand why this is failing now, but I don't know whose
> bug it is.
> 
> > This one looks like the interesting one: it's the PA thread:
> > 
> > > Thread 6 (Thread 0x7fffe359e710 (LWP 1508)):
> > > #0  0x00007fffe77369b0 in ?? ()
> > > No symbol table info available.
> > > #1  0x00007ffff574c9c7 in pa_command_request (pd=<value optimized out>, 
> > >     command=<value optimized out>, tag=<value optimized out>, t=0x270edf0, 
> > >     userdata=0x270a740) at pulse/stream.c:745
> > 
> > Here's the code:
> > 
> > 744    if (s->requested_bytes > 0 && s->write_callback)
> > 745        s->write_callback(s, (size_t) s->requested_bytes, s->write_userdata);
> 
> The crash I'm getting is that the callbacks used by the PulseAudio plugins in
> openal-soft and alsa-lib are each in the corresponding plugin. It's possible
> to induce something (Pulse? ALSA? who knows) to dlclose() the plugin, causing
> it to drop out of OpenArena's address space, while the Pulse thread is still
> happily streaming data. The next time the Pulse thread invokes the callback,
> SIGSEGV ensues.
> 
> So far I've only been able to reproduce this by setting the engine to
> use "ALSA Software" for output and the default "PulseAudio Capture" for
> input:
> 
>   openarena +set s_alDevice \"ALSA Software\" +set s_alCapture 1
> 
> (the quoting is strange for the Quake 3 engine's benefit, do run it exactly
> as given!)

It turns out that the pulseaudio backends in src:openal-soft and
src:alsa-plugins don't dlclose anything until the stream has stopped, so
they're (probably) OK.

However, when OpenArena is trying to work out which capture device to use, it
loads/probes/unloads all the OpenAL backends, including PortAudio. When the
PortAudio backend is unloaded, the OpenAL portaudio backend calls
Pa_Terminate(), which (perhaps among other things) calls Terminate() in
pa_linux_alsa.c. The last thing done in Terminate() is
a call to snd_config_update_free_global(). This calls dlclose on the
ALSA pcm_pulse plugin, which is unloaded; cue SIGSEGV when the PulseAudio
worker thread tries to call pcm_pulse's callbacks.

There is an ALSA bug about this:
    https://bugtrack.alsa-project.org/alsa-bug/view.php?id=2124
which is mentioned in a similar bug report:
    https://bugtrack.alsa-project.org/alsa-bug/view.php?id=4426

Possible resolutions include:

* Declare snd_config_update_free_global to be buggy, and remove the call to
  snd_dlobj_cache_cleanup (which appears to be a cleanup function that's
  not safe to be called in an unknown context, like xmlCleanupParser [1]).
  I think this is the real underlying bug, so I've reassigned this bug to ALSA.

* Treat snd_config_update_free_global() as an unsafe cleanup function,
  and don't call it in PortAudio (in which case reassign to libportaudio2,
  and hence the VoIP team).

* Treat Pa_Terminate() as an unsafe cleanup function, and don't call it in
  OpenAL. I can make this change on behalf of the Games Team if it's considered
  to be the best option.

* Decide that PortAudio support in OpenAL isn't useful for Debian, because
  OpenAL already acts as an abstraction layer supporting OSS, ALSA and
  PulseAudio, so the PortAudio backend just adds JACK support - which is
  intended for pro-audio rather than gaming - plus more "moving parts" that
  can go wrong. Again, I can make this change on behalf of the Games Team if
  it's considered the best - I have a hacked version of libopenal1 which
  refuses to load the PortAudio backend, and it does avoid this crash.

Thoughts from the ALSA/VoIP teams?

Thanks,
    Simon

[1] http://0pointer.de/blog/projects/beware-of-xmlCleanupParser
[signature.asc (application/pgp-signature, inline)]

Bug reassigned from package 'openarena' to 'libasound2'. Request was from Simon McVittie <smcv@debian.org> to control@bugs.debian.org. (Fri, 20 Aug 2010 18:27:05 GMT) Full text and rfc822 format available.

Bug No longer marked as found in versions openarena/0.8.5-3 and openarena/0.8.1-7. Request was from Simon McVittie <smcv@debian.org> to control@bugs.debian.org. (Fri, 20 Aug 2010 18:27:06 GMT) Full text and rfc822 format available.

Bug Marked as found in versions alsa-lib/1.0.23-1. Request was from Simon McVittie <smcv@debian.org> to control@bugs.debian.org. (Fri, 20 Aug 2010 18:27:08 GMT) Full text and rfc822 format available.

Added indication that 589896 affects openarena and libportaudio2 Request was from Simon McVittie <smcv@debian.org> to control@bugs.debian.org. (Fri, 20 Aug 2010 18:27:09 GMT) Full text and rfc822 format available.

Set Bug forwarded-to-address to 'https://bugtrack.alsa-project.org/alsa-bug/view.php?id=2124'. Request was from Elimar Riesebieter <riesebie@lxtec.de> to control@bugs.debian.org. (Fri, 20 Aug 2010 21:57:03 GMT) Full text and rfc822 format available.

Changed Bug forwarded-to-address to 'https://bugtrack.alsa-project.org/alsa-bug/view.php?id=4426' from 'https://bugtrack.alsa-project.org/alsa-bug/view.php?id=2124' Request was from Elimar Riesebieter <riesebie@lxtec.de> to control@bugs.debian.org. (Fri, 20 Aug 2010 21:57:04 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Debian ALSA Maintainers <pkg-alsa-devel@lists.alioth.debian.org>:
Bug#589896; Package libasound2. (Sat, 21 Aug 2010 18:09:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Simon McVittie <smcv@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian ALSA Maintainers <pkg-alsa-devel@lists.alioth.debian.org>. (Sat, 21 Aug 2010 18:09:03 GMT) Full text and rfc822 format available.

Message #31 received at 589896@bugs.debian.org (full text, mbox):

From: Simon McVittie <smcv@debian.org>
To: 589896@bugs.debian.org
Subject: Re: [Pkg-alsa-devel] Bug#589896: openarena: segfaults when using pulse-via-ALSA output and PulseAudio capture
Date: Sat, 21 Aug 2010 19:07:03 +0100
[Message part 1 (text/plain, inline)]
(You didn't cc me or the bug, so I didn't see this until I tried replying
with bts show --mbox to attach a proposed patch; please cc bugs and submitters
if you expect a response :-)

On Fri, 20 Aug 2010 at 23:56:02 +0200, Elimar Riesebieter wrote:
> There are already bugs in thet ALSA-BTS. So what do you expect?
> Another forward? I've tested openarena on my ppc-box and can't
> reproduce.....

I suggested removing the call to snd_dlobj_cache_cleanup(); I've now tested
this and confirmed that it works, see attached (trivial) patch.

There seem to be quite a few preconditions for the crash, since it's a bad
interaction between several layers of libraries and plugins. I can reproduce it
in sid with libpulse0 and libportaudio2 installed, pulseaudio running, ALSA
configured to use the pulse backend by default, the default OpenAL
configuration, and the following OpenArena command line:

    openarena +set s_alDevice \"ALSA Software\" +set s_alCapture 1

Note the strange quoting (because the command line is parsed once by the shell
then again by the Quake 3 engine), and that PortAudio is necessary to tickle
this bug; most other users of ALSA don't seem to call
snd_config_update_free_global(), possibly because this bug makes it unusable
for them.

This configuration may seem rather contrived, but it's surprisingly easy to get
by just upgrading things, because the Quake 3 engine auto-detects audio
devices, saves the chosen audio device in user configuration, and repeats
auto-detection if the saved or configured device no longer works.
The crash I originally reported was arrived at by upgrading, and Jordan
Metzmeier has seen a similar crash by running OA without PulseAudio
installed, with leftover configuration from when he previously did have it.

I can confirm that after reverting the other possible workarounds I've tried,
the OpenArena crash still occurs, but the attached patch prevents the crash
for me, with the "cost" that calling snd_config_update_free_global() no longer
unloads the plugins (but from its name and documentation, I wouldn't expect
it to do that anyway).

See the mail with which I reassigned to you for some other possible
ways to resolve this crash, if you don't think this is an ALSA bug.

    Simon
[snd_config_update_free_global.patch (text/x-diff, attachment)]
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian ALSA Maintainers <pkg-alsa-devel@lists.alioth.debian.org>:
Bug#589896; Package libasound2. (Sat, 21 Aug 2010 20:15:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Simon McVittie <smcv@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian ALSA Maintainers <pkg-alsa-devel@lists.alioth.debian.org>. (Sat, 21 Aug 2010 20:15:03 GMT) Full text and rfc822 format available.

Message #36 received at 589896@bugs.debian.org (full text, mbox):

From: Simon McVittie <smcv@debian.org>
To: 589896@bugs.debian.org
Subject: Re: [Pkg-alsa-devel] Bug#589896: openarena: segfaults when using pulse-via-ALSA output and PulseAudio capture
Date: Sat, 21 Aug 2010 21:11:44 +0100
forwarded 589896 https://bugtrack.alsa-project.org/alsa-bug/view.php?id=2124
tags 589896 + patch
thanks

On Sat, 21 Aug 2010 at 19:07:03 +0100, Simon McVittie wrote:
> I suggested removing the call to snd_dlobj_cache_cleanup(); I've now tested
> this and confirmed that it works, see attached (trivial) patch.

Now forwarded to https://bugtrack.alsa-project.org/alsa-bug/view.php?id=2124,
please add Forwarded: yes if you use the patch as-is :-)

Regards,
    Simon




Information forwarded to debian-bugs-dist@lists.debian.org, Debian ALSA Maintainers <pkg-alsa-devel@lists.alioth.debian.org>:
Bug#589896; Package libasound2. (Sat, 21 Aug 2010 21:00:06 GMT) Full text and rfc822 format available.

Acknowledgement sent to Elimar Riesebieter <riesebie@lxtec.de>:
Extra info received and forwarded to list. Copy sent to Debian ALSA Maintainers <pkg-alsa-devel@lists.alioth.debian.org>. (Sat, 21 Aug 2010 21:00:06 GMT) Full text and rfc822 format available.

Message #41 received at 589896@bugs.debian.org (full text, mbox):

From: Elimar Riesebieter <riesebie@lxtec.de>
To: Simon McVittie <smcv@debian.org>, 589896@bugs.debian.org
Subject: Re: [Pkg-alsa-devel] Bug#589896: Bug#589896: openarena: segfaults when using pulse-via-ALSA output and PulseAudio capture
Date: Sat, 21 Aug 2010 22:48:15 +0200
Hi Simon,

* Simon McVittie [100821 19:07 +0100]:
[...]
> I suggested removing the call to snd_dlobj_cache_cleanup(); I've now tested
> this and confirmed that it works, see attached (trivial) patch.

Thanks for the patch and your engagement. I want to point out that

- Where should the patch be applied to? We have many 'src' dirs in
  OSS and ALSA as well ;-)

- This should not be a Debian specific solution. So I want encourage
  you to send your patch upstream. So every fanatic quaker (like I
  was in the past) has advantage of your patch independent from any
  distro, though.

- Hmm, did you tested oa with a clean ALSA install without any
  soundserver running? And a virgin or not existent ~/.asoundrc?

Thanks for your effort.

Elimar


-- 
  Learned men are the cisterns of knowledge, 
  not the fountainheads ;-)




Information forwarded to debian-bugs-dist@lists.debian.org, Debian ALSA Maintainers <pkg-alsa-devel@lists.alioth.debian.org>:
Bug#589896; Package libasound2. (Sat, 21 Aug 2010 21:33:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to Simon McVittie <smcv@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian ALSA Maintainers <pkg-alsa-devel@lists.alioth.debian.org>. (Sat, 21 Aug 2010 21:33:02 GMT) Full text and rfc822 format available.

Message #46 received at 589896@bugs.debian.org (full text, mbox):

From: Simon McVittie <smcv@debian.org>
To: 589896@bugs.debian.org, Elimar Riesebieter <riesebie@lxtec.de>
Subject: Re: [Pkg-alsa-devel] Bug#589896: openarena: segfaults when using pulse-via-ALSA output and PulseAudio capture
Date: Sat, 21 Aug 2010 22:28:51 +0100
On Sat, 21 Aug 2010 at 22:48:15 +0200, Elimar Riesebieter wrote:
> - Where should the patch be applied to? We have many 'src' dirs in
>   OSS and ALSA as well ;-)

The package to which I'd previously reassigned the bug :-)

(libasound2, part of src:alsa-lib.)

> - This should not be a Debian specific solution. So I want encourage
>   you to send your patch upstream. So every fanatic quaker (like I
>   was in the past) has advantage of your patch independent from any
>   distro, though.

I did:

On Sat, 21 Aug 2010 at 21:11:44 +0100, Simon McVittie wrote:
> Now forwarded to https://bugtrack.alsa-project.org/alsa-bug/view.php?id=2124,
> please add Forwarded: yes if you use the patch as-is :-)

... but that bug has been open since 2006 and untouched since 2009, so I
don't hold out much hope for fixing this upstream before squeeze
(or for the release team letting in a new upstream release).

> - Hmm, did you tested oa with a clean ALSA install without any
>   soundserver running? And a virgin or not existent ~/.asoundrc?

That's not an affected configuration, since the bug applies to (as the
reporter of the upstream bug put it) "applications using user space alsa
plugins". The pulse backend is one such.

But, since you insist:

When I rename my ~/.asoundrc away and downgrade to the current (unpatched)
version of alsa-lib, the crash doesn't occur.

When I reinstate this configuration, it returns:

	pcm.!default {
		type pulse
	}

With the patched version of alsa-lib, neither the default configuration
nor the pulse configuration causes the crash, the default configuration works
with no sound server running, and the pulse configuration automatically
restarts pulseaudio.

    S




Information forwarded to debian-bugs-dist@lists.debian.org, Debian ALSA Maintainers <pkg-alsa-devel@lists.alioth.debian.org>:
Bug#589896; Package libasound2. (Mon, 23 Aug 2010 12:57:09 GMT) Full text and rfc822 format available.

Acknowledgement sent to Mark Brown <broonie@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian ALSA Maintainers <pkg-alsa-devel@lists.alioth.debian.org>. (Mon, 23 Aug 2010 12:57:09 GMT) Full text and rfc822 format available.

Message #51 received at 589896@bugs.debian.org (full text, mbox):

From: Mark Brown <broonie@debian.org>
To: pkg-alsa-devel@lists.alioth.debian.org
Cc: 589896@bugs.debian.org
Subject: Re: [Pkg-alsa-devel] Bug#589896: openarena: segfaults when using pulse-via-ALSA output and PulseAudio capture
Date: Mon, 23 Aug 2010 13:55:30 +0100
On Fri, Aug 20, 2010 at 11:56:02PM +0200, Elimar Riesebieter wrote:
> forwarded 589896 https://bugtrack.alsa-project.org/alsa-bug/view.php?id=2124
> forwarded 589896 https://bugtrack.alsa-project.org/alsa-bug/view.php?id=4426
> thanks

> > Thoughts from the ALSA/VoIP teams?

> There are already bugs in thet ALSA-BTS. So what do you expect?
> Another forward? I've tested openarena on my ppc-box and can't
> reproduce.....

The ALSA BTS is essentially totally abandoned, to forward ALSA stuff
upstream you really need to post to alsa-devel.




Information forwarded to debian-bugs-dist@lists.debian.org, Debian ALSA Maintainers <pkg-alsa-devel@lists.alioth.debian.org>:
Bug#589896; Package libasound2. (Mon, 23 Aug 2010 13:03:06 GMT) Full text and rfc822 format available.

Acknowledgement sent to Mark Brown <broonie@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian ALSA Maintainers <pkg-alsa-devel@lists.alioth.debian.org>. (Mon, 23 Aug 2010 13:03:06 GMT) Full text and rfc822 format available.

Message #56 received at 589896@bugs.debian.org (full text, mbox):

From: Mark Brown <broonie@debian.org>
To: Simon McVittie <smcv@debian.org>, 589896@bugs.debian.org
Subject: Re: [Pkg-alsa-devel] Bug#589896: Bug#589896: openarena: segfaults when using pulse-via-ALSA output and PulseAudio capture
Date: Mon, 23 Aug 2010 13:58:36 +0100
On Sat, Aug 21, 2010 at 09:11:44PM +0100, Simon McVittie wrote:
> forwarded 589896 https://bugtrack.alsa-project.org/alsa-bug/view.php?id=2124
> tags 589896 + patch
> thanks

> On Sat, 21 Aug 2010 at 19:07:03 +0100, Simon McVittie wrote:
> > I suggested removing the call to snd_dlobj_cache_cleanup(); I've now tested
> > this and confirmed that it works, see attached (trivial) patch.

> Now forwarded to https://bugtrack.alsa-project.org/alsa-bug/view.php?id=2124,
> please add Forwarded: yes if you use the patch as-is :-)

Didn't see you'd been dropped from previous mails so repeating:

The ALSA BTS is essentially abandoned upstream, you need to contact the
developers via e-mail (alsa-devel@alsa-project.org) to bring things to
their attention.




Information forwarded to debian-bugs-dist@lists.debian.org, Debian ALSA Maintainers <pkg-alsa-devel@lists.alioth.debian.org>:
Bug#589896; Package libasound2. (Mon, 23 Aug 2010 15:27:08 GMT) Full text and rfc822 format available.

Acknowledgement sent to Dan Chen <crimsunkg@yahoo.com>:
Extra info received and forwarded to list. Copy sent to Debian ALSA Maintainers <pkg-alsa-devel@lists.alioth.debian.org>. (Mon, 23 Aug 2010 15:27:08 GMT) Full text and rfc822 format available.

Message #61 received at 589896@bugs.debian.org (full text, mbox):

From: Dan Chen <crimsunkg@yahoo.com>
To: 589896@bugs.debian.org
Subject: Re: [Pkg-alsa-devel] Bug#589896: Bug#589896: openarena: segfaults when using pulse-via-ALSA output and PulseAudio capture
Date: Mon, 23 Aug 2010 08:24:44 -0700 (PDT)
[Apologies for top-posting due to broken MUA]

Please see
http://git.alsa-project.org/?p=alsa-lib.git;a=commitdiff_plain;h=91c9c8f1b85e69b4bdc94a777d2767c4906c3f47

which was just raised on the alsa-devel mailing list.

-D



----- Original Message ----
From: Simon McVittie <smcv@debian.org>
To: 589896@bugs.debian.org
Sent: Sat, August 21, 2010 2:07:03 PM
Subject: [Pkg-alsa-devel] Bug#589896: Bug#589896: openarena: segfaults when 
using pulse-via-ALSA output
and PulseAudio capture

(You didn't cc me or the bug, so I didn't see this until I tried replying
with bts show --mbox to attach a proposed patch; please cc bugs and submitters
if you expect a response :-)

On Fri, 20 Aug 2010 at 23:56:02 +0200, Elimar Riesebieter wrote:
> There are already bugs in thet ALSA-BTS. So what do you expect?
> Another forward? I've tested openarena on my ppc-box and can't
> reproduce.....

I suggested removing the call to snd_dlobj_cache_cleanup(); I've now tested
this and confirmed that it works, see attached (trivial) patch.



      





Information forwarded to debian-bugs-dist@lists.debian.org, Debian ALSA Maintainers <pkg-alsa-devel@lists.alioth.debian.org>:
Bug#589896; Package libasound2. (Fri, 08 Oct 2010 08:30:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Simon McVittie <smcv@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian ALSA Maintainers <pkg-alsa-devel@lists.alioth.debian.org>. (Fri, 08 Oct 2010 08:30:03 GMT) Full text and rfc822 format available.

Message #66 received at 589896@bugs.debian.org (full text, mbox):

From: Simon McVittie <smcv@debian.org>
To: Dan Chen <crimsunkg@yahoo.com>, 589896@bugs.debian.org
Subject: Re: Bug#589896: openarena: segfaults when using pulse-via-ALSA output and PulseAudio capture
Date: Fri, 8 Oct 2010 09:26:50 +0100
[Message part 1 (text/plain, inline)]
tags 589896 + patch
thanks

On Mon, 23 Aug 2010 at 08:24:44 -0700, Dan Chen wrote:
> [Apologies for top-posting due to broken MUA]
> 
> Please see
> http://git.alsa-project.org/?p=alsa-lib.git;a=commitdiff_plain;h=91c9c8f1b85e69b4bdc94a777d2767c4906c3f47

Thanks, I've backported this patch and prepared an NMU.

I attach the backported patch; nmudiff to follow.

    S
[refcount-dlobjs.patch (text/x-diff, attachment)]
[signature.asc (application/pgp-signature, inline)]

Added tag(s) patch. Request was from Simon McVittie <smcv@debian.org> to control@bugs.debian.org. (Fri, 08 Oct 2010 08:30:04 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Debian ALSA Maintainers <pkg-alsa-devel@lists.alioth.debian.org>:
Bug#589896; Package libasound2. (Fri, 08 Oct 2010 08:42:04 GMT) Full text and rfc822 format available.

Acknowledgement sent to Simon McVittie <smcv@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian ALSA Maintainers <pkg-alsa-devel@lists.alioth.debian.org>. (Fri, 08 Oct 2010 08:42:04 GMT) Full text and rfc822 format available.

Message #73 received at 589896@bugs.debian.org (full text, mbox):

From: Simon McVittie <smcv@debian.org>
To: 589896@bugs.debian.org
Subject: alsa-lib: diff for NMU version 1.0.23-2.1
Date: Fri, 8 Oct 2010 09:40:18 +0100
[Message part 1 (text/plain, inline)]
tags 589896 + pending
thanks

I've prepared an NMU for alsa-lib (versioned as 1.0.23-2.1) and
uploaded it to DELAYED/14, and will ping the release team about an unblock.
Please let me know if I should cancel the NMU.

Regards,
    S
[alsa-lib-1.0.23-2.1-nmu.diff (text/x-diff, attachment)]
[signature.asc (application/pgp-signature, inline)]

Added tag(s) pending. Request was from Simon McVittie <smcv@debian.org> to control@bugs.debian.org. (Fri, 08 Oct 2010 08:42:12 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Debian ALSA Maintainers <pkg-alsa-devel@lists.alioth.debian.org>:
Bug#589896; Package libasound2. (Wed, 20 Oct 2010 13:57:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Simon McVittie <smcv@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian ALSA Maintainers <pkg-alsa-devel@lists.alioth.debian.org>. (Wed, 20 Oct 2010 13:57:03 GMT) Full text and rfc822 format available.

Message #80 received at 589896@bugs.debian.org (full text, mbox):

From: Simon McVittie <smcv@debian.org>
To: 599510@bugs.debian.org
Cc: 589896@bugs.debian.org
Subject: Re: future unblock: alsa-lib/1.0.23-2.1
Date: Wed, 20 Oct 2010 14:54:05 +0100
On Fri, 08 Oct 2010 at 10:01:07 +0100, Simon McVittie wrote:
> I've uploaded a delayed/14 NMU for alsa-lib, for
> http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=589896 (crashes due to
> unloading plugins that are still in use), by backporting a patch from
> upstream. Its diffstat looks like this:
[...]
>  7 files changed, 151 insertions(+), 121 deletions(-)
> 
> The full patch and the nmudiff are on #589896:
[...]
> If this is too intrusive for squeeze, there are potential workarounds for
> #589896 in either alsa-lib (don't unload plugins whether they're in use or
> not), PortAudio (don't tell ALSA to unload plugins), or OpenAL (forcibly
> disable PortAudio support, since PortAudio is the only backend that actually
> tells ALSA to unload plugins, and isn't incredibly useful on Linux). There are
> more details on the bug.

Hi release team,

Any thoughts on this? The NMU will come out of DELAYED in a couple of days
unless I intervene, so please let me know if I should cancel it and
prepare a package with one of the less intrusive workarounds instead.

Thanks,
    S




Information forwarded to debian-bugs-dist@lists.debian.org, Debian ALSA Maintainers <pkg-alsa-devel@lists.alioth.debian.org>:
Bug#589896; Package libasound2. (Wed, 20 Oct 2010 17:48:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Elimar Riesebieter <riesebie@lxtec.de>:
Extra info received and forwarded to list. Copy sent to Debian ALSA Maintainers <pkg-alsa-devel@lists.alioth.debian.org>. (Wed, 20 Oct 2010 17:48:03 GMT) Full text and rfc822 format available.

Message #85 received at 589896@bugs.debian.org (full text, mbox):

From: Elimar Riesebieter <riesebie@lxtec.de>
To: Simon McVittie <smcv@debian.org>, 589896@bugs.debian.org
Cc: 599510@bugs.debian.org, release.debian.org@packages.debian.org
Subject: Re: [Pkg-alsa-devel] Bug#589896: future unblock: alsa-lib/1.0.23-2.1
Date: Wed, 20 Oct 2010 19:45:08 +0200
* Simon McVittie [101020 14:54 +0100]:
> On Fri, 08 Oct 2010 at 10:01:07 +0100, Simon McVittie wrote:
> > I've uploaded a delayed/14 NMU for alsa-lib, for
> > http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=589896 (crashes due to
> > unloading plugins that are still in use), by backporting a patch from
> > upstream. Its diffstat looks like this:
> [...]
> >  7 files changed, 151 insertions(+), 121 deletions(-)
> > 
> > The full patch and the nmudiff are on #589896:
> [...]
> > If this is too intrusive for squeeze, there are potential workarounds for
> > #589896 in either alsa-lib (don't unload plugins whether they're in use or
> > not), PortAudio (don't tell ALSA to unload plugins), or OpenAL (forcibly
> > disable PortAudio support, since PortAudio is the only backend that actually
> > tells ALSA to unload plugins, and isn't incredibly useful on Linux). There are
> > more details on the bug.
> 
> Hi release team,
> 
> Any thoughts on this? The NMU will come out of DELAYED in a couple of days
> unless I intervene, so please let me know if I should cancel it and
> prepare a package with one of the less intrusive workarounds instead.

We should wait till 1.0.24 is released. This version doesn't need
that patch. Interested oa gamers should load sid after squeeze
release, though.

Elimar


-- 
  The path to source is always uphill!
                                -unknown-




Information forwarded to debian-bugs-dist@lists.debian.org, Debian ALSA Maintainers <pkg-alsa-devel@lists.alioth.debian.org>:
Bug#589896; Package libasound2. (Wed, 20 Oct 2010 18:27:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Julien Cristau <jcristau@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian ALSA Maintainers <pkg-alsa-devel@lists.alioth.debian.org>. (Wed, 20 Oct 2010 18:27:03 GMT) Full text and rfc822 format available.

Message #90 received at 589896@bugs.debian.org (full text, mbox):

From: Julien Cristau <jcristau@debian.org>
To: Simon McVittie <smcv@debian.org>, 599510@bugs.debian.org
Cc: 589896@bugs.debian.org
Subject: Re: Bug#599510: future unblock: alsa-lib/1.0.23-2.1
Date: Wed, 20 Oct 2010 20:24:54 +0200
[Message part 1 (text/plain, inline)]
On Wed, Oct 20, 2010 at 14:54:05 +0100, Simon McVittie wrote:

> On Fri, 08 Oct 2010 at 10:01:07 +0100, Simon McVittie wrote:
> > I've uploaded a delayed/14 NMU for alsa-lib, for
> > http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=589896 (crashes due to
> > unloading plugins that are still in use), by backporting a patch from
> > upstream. Its diffstat looks like this:
> [...]
> >  7 files changed, 151 insertions(+), 121 deletions(-)
> > 
> > The full patch and the nmudiff are on #589896:
> [...]
> > If this is too intrusive for squeeze, there are potential workarounds for
> > #589896 in either alsa-lib (don't unload plugins whether they're in use or
> > not), PortAudio (don't tell ALSA to unload plugins), or OpenAL (forcibly
> > disable PortAudio support, since PortAudio is the only backend that actually
> > tells ALSA to unload plugins, and isn't incredibly useful on Linux). There are
> > more details on the bug.
> 
> Hi release team,
> 
> Any thoughts on this? The NMU will come out of DELAYED in a couple of days
> unless I intervene, so please let me know if I should cancel it and
> prepare a package with one of the less intrusive workarounds instead.
> 
Sorry for the delay.  The NMU diff looks reasonable to me, thanks.  Let
me know when it lands and I'll unblock the package.

Cheers,
Julien
[signature.asc (application/pgp-signature, inline)]

Reply sent to Simon McVittie <smcv@debian.org>:
You have taken responsibility. (Fri, 22 Oct 2010 09:33:06 GMT) Full text and rfc822 format available.

Notification sent to Simon McVittie <smcv@debian.org>:
Bug acknowledged by developer. (Fri, 22 Oct 2010 09:33:06 GMT) Full text and rfc822 format available.

Message #95 received at 589896-close@bugs.debian.org (full text, mbox):

From: Simon McVittie <smcv@debian.org>
To: 589896-close@bugs.debian.org
Subject: Bug#589896: fixed in alsa-lib 1.0.23-2.1
Date: Fri, 22 Oct 2010 09:32:12 +0000
Source: alsa-lib
Source-Version: 1.0.23-2.1

We believe that the bug you reported is fixed in the latest version of
alsa-lib, which is due to be installed in the Debian FTP archive:

alsa-lib_1.0.23-2.1.debian.tar.bz2
  to main/a/alsa-lib/alsa-lib_1.0.23-2.1.debian.tar.bz2
alsa-lib_1.0.23-2.1.dsc
  to main/a/alsa-lib/alsa-lib_1.0.23-2.1.dsc
lib32asound2-dev_1.0.23-2.1_amd64.deb
  to main/a/alsa-lib/lib32asound2-dev_1.0.23-2.1_amd64.deb
lib32asound2_1.0.23-2.1_amd64.deb
  to main/a/alsa-lib/lib32asound2_1.0.23-2.1_amd64.deb
libasound2-dev_1.0.23-2.1_amd64.deb
  to main/a/alsa-lib/libasound2-dev_1.0.23-2.1_amd64.deb
libasound2-doc_1.0.23-2.1_all.deb
  to main/a/alsa-lib/libasound2-doc_1.0.23-2.1_all.deb
libasound2_1.0.23-2.1_amd64.deb
  to main/a/alsa-lib/libasound2_1.0.23-2.1_amd64.deb



A summary of the changes between this version and the previous one is
attached.

Thank you for reporting the bug, which will now be closed.  If you
have further comments please address them to 589896@bugs.debian.org,
and the maintainer will reopen the bug report if appropriate.

Debian distribution maintenance software
pp.
Simon McVittie <smcv@debian.org> (supplier of updated alsa-lib package)

(This message was generated automatically at their request; if you
believe that there is a problem with it please contact the archive
administrators by mailing ftpmaster@debian.org)


-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA256

Format: 1.8
Date: Fri, 08 Oct 2010 08:30:54 +0100
Source: alsa-lib
Binary: libasound2 libasound2-dev lib64asound2 lib64asound2-dev lib32asound2 lib32asound2-dev libasound2-doc
Architecture: source amd64 all
Version: 1.0.23-2.1
Distribution: unstable
Urgency: low
Maintainer: Debian ALSA Maintainers <pkg-alsa-devel@lists.alioth.debian.org>
Changed-By: Simon McVittie <smcv@debian.org>
Description: 
 lib32asound2 - shared library for ALSA applications (32 bit)
 lib32asound2-dev - shared library for ALSA applications -- development files (32 bit
 lib64asound2 - shared library for ALSA applications (64 bit)
 lib64asound2-dev - shared library for ALSA applications -- development files (64 bit
 libasound2 - shared library for ALSA applications
 libasound2-dev - shared library for ALSA applications -- development files
 libasound2-doc - developer documentation for user-space ALSA application programmi
Closes: 589896
Changes: 
 alsa-lib (1.0.23-2.1) unstable; urgency=low
 .
   * Non-maintainer upload.
   * Add refcount-dlobjs.patch: backported upstream patch, originally by
     Jaroslav Kysela, to fix crashes when plugins are unloaded.
     (Closes: #589896, LP: #552411, #584393)
   * Add libtool-out-of-tree.patch: fix libtool version checking for the biarch
     build by grepping ltmain.sh in the ${srcdir}, making it unnecessary to
     force -DUSE_VERSIONED_SYMBOLS for the biarch build
Checksums-Sha1: 
 0a3ca2d54164c838fb2ea62459094dfc2d64b858 2480 alsa-lib_1.0.23-2.1.dsc
 7c45c08ec57cabc289ad4f0b8502e530cf83e63d 424533 alsa-lib_1.0.23-2.1.debian.tar.bz2
 6b7463c04703b28a4dd1a03eca487969c360e79c 421294 libasound2_1.0.23-2.1_amd64.deb
 9d542904b1e6079f1c94852f5153af24a310932c 562748 libasound2-dev_1.0.23-2.1_amd64.deb
 d7de8982fe136271867002696af56c594a5331a7 326634 lib32asound2_1.0.23-2.1_amd64.deb
 18851eb75fde4f2d8007d1fe04edff6d5e3a9673 447104 lib32asound2-dev_1.0.23-2.1_amd64.deb
 3e72b2c5a74d37f46ba63d1fe66159edab8b42ea 1457620 libasound2-doc_1.0.23-2.1_all.deb
Checksums-Sha256: 
 43c5bb1c17a1fa0e5012a01de7901a8cccb595a3bc3935dbee33338033fbd4e0 2480 alsa-lib_1.0.23-2.1.dsc
 6d8c1f61fa720ab855ca3a41d112891e09f7d0fe7703348d859443226a4e190c 424533 alsa-lib_1.0.23-2.1.debian.tar.bz2
 03769d8026bff9303e8e060d64c1c73f937f1593222aec0b261fe5a0ecfbf858 421294 libasound2_1.0.23-2.1_amd64.deb
 b098b3a8789fb41bc1788d62ff7c258a6f3e8d2011bce9f158874ed18beef0ca 562748 libasound2-dev_1.0.23-2.1_amd64.deb
 02af99ca0ac7c8a1fcdcd01234996c75111c325437e74af66b27b458ffcb64fe 326634 lib32asound2_1.0.23-2.1_amd64.deb
 8c41cb7d290d35f2aa9dd5c0414f92f34bad7f53246a4eb5db02cb0e05f2e89a 447104 lib32asound2-dev_1.0.23-2.1_amd64.deb
 bc36c763c69f3977cdbc3d79a0f8460b13f4339d9e8b090351bc0ce08011db51 1457620 libasound2-doc_1.0.23-2.1_all.deb
Files: 
 936d65f3ba3b81fcd17ba0bb3034dae3 2480 libs optional alsa-lib_1.0.23-2.1.dsc
 95ddf5ae05f2050dda3bc7897bb79228 424533 libs optional alsa-lib_1.0.23-2.1.debian.tar.bz2
 6524df8139b5caf0281dfeca87700729 421294 libs optional libasound2_1.0.23-2.1_amd64.deb
 e6e2566b7b1573e854354723d20b9ff3 562748 libdevel optional libasound2-dev_1.0.23-2.1_amd64.deb
 bad5dbe8b3f1247f58c6345b82830424 326634 libs optional lib32asound2_1.0.23-2.1_amd64.deb
 3587ffe0149ddaced7b721d034c5f171 447104 libdevel optional lib32asound2-dev_1.0.23-2.1_amd64.deb
 4ef2ffc325e56089eaa5b500d3b486c3 1457620 doc optional libasound2-doc_1.0.23-2.1_all.deb

-----BEGIN PGP SIGNATURE-----

iQIVAwUBTK7ZJU3o/ypjx8yQAQhSEw/9E8wvapo5lbFvHSQILMo30+ufuBWNyMPM
usagh26/pnwOWEPrEAnjNHj61fPmJUAX2j7ra0X/yC6zx08NkU+UZvOLUfU4Vtz1
ZIbo0z3ZFMRj6sAhFyoCbRD2Hi1dZROKimWFZ4UHSWz0EN5m6xOkiFSpVtiOl1q6
i4VHsVJGtcWRKENpfOQ8uoIrEx+c9psBT/kNt9fa3n8yA2+U230rMyd7P2838zLr
ja0FoGSHW5UzaSWsTa2z3yYAQjE5tXvAYKvFJ6Xe+QPI+odoV1Nlxcw15SzR8DSS
PTDHFr8CjcaTxu8yIhIdwyFvbHOXpX8JAVvY/rmLnL8ikrLDHFTkbWUgmAWlJMww
84N3p7MU+ekpLC2FKGowjsrsSfSXGgwmQRKrGxthfmLx9YZnfxgTQaUtGXbm2bqA
VXuqkKtR5r5LcmMoeEQqkcoo1oAgO85bdC6lGDqShZRtQPjSgqsYHOPeLy8j5h9h
zf8CDCXO/NM50lmWh/xYMddfcPGjfMhF/5GC10XGOG4P36NUkhYr7Fjm0vIKFpbf
ZMCXcKY9TTxAoQG1m0QnEyDuPcMp9Y8cu2knJUN6Q5rgQyaR3EbSGuOvZR3wXVYI
o4vac2q8EgR8BpZ1Hwhz3/zCB8d2FtP3axTslpLA/7ocY7cXssjSST5KD9Xc11P2
qhwx+aOgCBo=
=hECS
-----END PGP SIGNATURE-----





Reply sent to Simon McVittie <smcv@debian.org>:
You have taken responsibility. (Fri, 22 Oct 2010 09:33:07 GMT) Full text and rfc822 format available.

Notification sent to Jordan Metzmeier <jordan@linuxgen.com>:
Bug acknowledged by developer. (Fri, 22 Oct 2010 09:33:07 GMT) Full text and rfc822 format available.

Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Tue, 30 Nov 2010 07:32:08 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Mon Apr 21 10:40:33 2014; Machine Name: buxtehude.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.